
#include <allegro.h>
#include <iostream>
#include <vector>
#include <math.h>
#include <list>
#include <set>
#include <fstream>
#include <algorithm>
#ifdef __APPLE__
#include <ApplicationServices/ApplicationServices.h>
#endif
#include "random.hpp"
#include "map.txt"

using namespace std;

BITMAP* buffer;

BITMAP* leveltiles;
BITMAP* playersprite;
BITMAP* vignette;
BITMAP* collectable;
BITMAP* bg;
BITMAP* fg;
FONT* f;
char itemcounttext[30];

const int TILE_WIDTH=11;
const int TILE_HEIGHT=14;

const int SCREEN_WIDTH=800;
const int SCREEN_HEIGHT=600;

const int endx=55; const int endy=8;


int magenta;
int red;
int lightred;
int black;
int white;
int green;
int lightgreen;
int orange;
int purp0;
int purp1;
int purp2;
int grey;
int lightgrey;
int blue;
int yellow;
int bgcol;

void cutbars()
{
	rectfill(buffer, 0, 0, SCREEN_WIDTH, 200, black);
	rectfill(buffer, 0, SCREEN_HEIGHT-200, SCREEN_WIDTH, SCREEN_HEIGHT, black);
}

#define STARTANIM \
int j=0; \
if (false) {
#define DURATION(x) } else if (t<(j+=x)) {
#define ENDANIM } else return true; return false;
#define POSITION(entity,posx,posy,frameno) \
entity.x=posx;\
entity.y=posy;\
entity.frame=frameno;
#define DRAW(frame,x) masked_blit(vignette, buffer, frame*TILE_WIDTH, 0, x, SCREEN_HEIGHT/2-20, TILE_WIDTH, TILE_HEIGHT);
#define DRAWDROP(frame,x) masked_blit(vignette, buffer, frame*TILE_WIDTH, 0, x, SCREEN_HEIGHT/2-18, TILE_WIDTH, TILE_HEIGHT);
#define DRAWABOVE(frame,x) masked_blit(vignette, buffer, frame*TILE_WIDTH, 0, x, SCREEN_HEIGHT/2-18-5, TILE_WIDTH, TILE_HEIGHT);
#define LEFT(x) textout_ex(buffer, f, x, 1, 19, makecol(255,255,255), -1);
#define RIGHT(x) textout_right_ex(buffer, f, x, SCREEN_WIDTH-2, 19, makecol(255,255,255), -1);
#define CUTBARS cutbars();
#define CENTER(x) textout_centre_ex(buffer, f, x, SCREEN_WIDTH/2, SCREEN_HEIGHT/2-50, black, -1);

#define SCENTER(x) textout_centre_ex(buffer, f, x, SCREEN_WIDTH/2, 19, white, -1);

template<int ending>
bool anim(int t);

template<>
bool anim<0>(int t)
{
	STARTANIM
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,250)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,280)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,300)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,340)
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,360)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,380)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,400)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,420)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,440)
	CENTER("loser");
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,440)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,460)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,480)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,500)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,520)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,540)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,560)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,580)
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,600)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,620)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,640)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,660)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,680)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,700)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,720)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,740)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,760)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,780)
	
	
	
	ENDANIM
	
}


template<>
bool anim<1>(int t)
{
		STARTANIM
		
		DURATION(60)
		DRAW(0,357)
		DRAW(1,377)
		DRAW(2,397)
		DRAW(12,250)
		
		
		DURATION(60)
		DRAW(0,357)
		DRAW(1,377)
		DRAW(2,397)
		DRAW(12,280)
		
		
		DURATION(60)
		DRAW(0,357)
		DRAW(1,377)
		DRAW(2,397)
		DRAW(12,300)
		
		
		DURATION(60)
		DRAW(0,357)
		DRAW(1,377)
		DRAW(2,397)
		DRAW(12,320)
		
		DURATION(60)
		DRAW(0,357)
		DRAW(1,377)
		DRAW(2,397)
		DRAW(12,320)
		
		DURATION(60)
		DRAW(0,347)
		DRAW(1,377)
		DRAW(2,397)
		DRAW(12,320)
		
		
		DURATION(120)
		DRAW(0,347)
		DRAW(1,377)
		DRAW(2,397)
		DRAW(12,320)
		CENTER("What's that you got there?")

		
		DURATION(120)
		DRAW(0,347)
		DRAW(1,377)
		DRAW(2,397)
		DRAW(12,320)
		
		DURATION(120)
		DRAW(0,347)
		DRAW(1,377)
		DRAW(2,397)
		DRAW(12,320)
		CENTER("Why don't you just give it to me?")
	
	
	DURATION(60)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	DRAW(0,325)
	
	DURATION(120)
	DRAW(1,377)
	DRAW(2,397)
	DRAWDROP(7,320)
	DRAWABOVE(13,330)
	DRAW(0,330)
		
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,340)
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,360)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,380)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,400)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,420)

	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,440)

	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,460)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,480)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,500)
	
	
	
	DURATION(120)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,520)
	CENTER("Faggot.")

	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,540)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,560)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,580)
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,600)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,620)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,640)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,660)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,680)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,700)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,720)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,740)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,760)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,780)
	
		
	ENDANIM
	
}



template<>
bool anim<2>(int t)
{
	STARTANIM
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,250)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,280)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,300)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	
	
	DURATION(120)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	CENTER("What's that shit you got?")
	
	
	DURATION(120)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	
	
	DURATION(60)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	DRAW(0,325)
	
	DURATION(160)
	DRAW(1,377)
	DRAW(2,397)
	DRAWDROP(12,320)
	DRAWDROP(14,330)
	DRAW(0,330)
	
	
	DURATION(120)
	DRAW(1,377)
	DRAW(2,397)
	DRAWDROP(12,320)
	DRAWDROP(14,330)
	DRAW(0,330)
	CENTER("Looks like trash to me.")
	
	
	DURATION(60)
	DRAW(0,330)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,300)
	DRAW(14,330)
	
	DURATION(20)
	DRAW(0,330)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,300)
	DRAWDROP(14,330)
	
	
	DURATION(20)
	DRAW(0,330)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,300)
	DRAWDROP(14,330)
	
	//---
	
	
	
	DURATION(20)
	DRAWABOVE(0,330)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,300)
	DRAWDROP(14,330)
	
	
	
	
	DURATION(20)
	DRAW(0,330)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,300)
	DRAWDROP(14,330)
	
	
	
	
	DURATION(20)
	DRAWABOVE(0,330)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,300)
	DRAWDROP(14,330)
	
	
	
	
	DURATION(20)
	DRAW(0,330)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,300)
	DRAWDROP(14,330)
	
	
	DURATION(20)
	DRAWABOVE(0,330)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,300)
	DRAWDROP(15,330)
	
	
	
	
	DURATION(20)
	DRAW(0,330)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,300)
	DRAWDROP(15,330)
	
	
	
	
	//---
	
	
	
	
	
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,300)
	DRAWDROP(15,330)
	
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,300)
	DRAWDROP(15,330)
	
	
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	DRAWDROP(15,330)
	
	
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	DRAWDROP(15,330)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,340)
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,360)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,380)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,400)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,420)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,440)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,460)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,480)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,500)
	
	
	
	DURATION(120)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,520)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,540)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,560)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,580)
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,600)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,620)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,640)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,660)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,680)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,700)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,720)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,740)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,760)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,780)
	
	
	ENDANIM
	
}



template<>
bool anim<3>(int t)
{
	STARTANIM
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,250)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,280)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,300)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	
	
	DURATION(120)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	CENTER("Well look who it is...")
	
	
	
	DURATION(120)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	
	DURATION(120)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)	
	
	DURATION(60)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	DRAW(0,325)
	
	DURATION(120)
	DRAW(1,377)
	DRAW(2,397)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(0,330)

	
	DURATION(120)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	
	
	DURATION(120)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(1,347)
	
	
	DURATION(120)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(1,327)
	
	
	DURATION(120)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(1,315)
	
	
	DURATION(120)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(3,315)
	
	DURATION(20)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(4,315)
	
	DURATION(20)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(5,315)
	
	DURATION(20)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(4,315)
	
	DURATION(20)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(5,315)
	
	DURATION(20)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(4,315)
	
	DURATION(20)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(6,323)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(5,315)

	DURATION(20)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(6,323)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(4,315)
	
	DURATION(20)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(6,323)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(5,315)
	
	DURATION(20)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(6,323)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(4,315)
	
	DURATION(20)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(6,323)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(5,315)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(6,323)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(3,315)
	
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(6,323)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(1,315)
	
	
	
	DURATION(120)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(6,323)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(1,315)
	CENTER("Good one!")
	
	
	DURATION(40)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(6,323)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(1,315)
	
	
	DURATION(40)
	DRAWABOVE(0,357)
	DRAWABOVE(2,397)
	DRAWDROP(6,323)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(1,315)
	
	DURATION(40)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(6,323)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(1,315)
	
	
	DURATION(40)
	DRAWABOVE(0,357)
	DRAWABOVE(2,397)
	DRAWDROP(6,323)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(1,315)
	
	DURATION(40)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(6,323)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(1,315)
	
	
	DURATION(40)
	DRAWABOVE(0,357)
	DRAWABOVE(2,397)
	DRAWDROP(6,323)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(1,315)
	
	
	DURATION(300)
	DRAW(0,357)
	DRAW(2,397)
	DRAWDROP(6,323)
	DRAWDROP(7,320)
	DRAWDROP(16,310)
	DRAW(1,315)
	
	ENDANIM
	
}



template<>
bool anim<4>(int t)
{
	STARTANIM
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,250)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,280)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,300)
	
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	
	DURATION(60)
	DRAW(0,357)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	
	
	DURATION(120)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	CENTER("Look at that fucker.")
	
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	
	
	DURATION(120)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	CENTER("Thinks he's better than us.")
	
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	
	
	DURATION(120)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)
	CENTER("Let's teach him a lesson.")
	
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,397)
	DRAW(12,320)

	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,387)
	DRAW(12,320)

	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,367)
	DRAW(12,320)
	
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,337)
	DRAW(12,320)
	
	DURATION(20)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,327)
	DRAW(12,320)
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,337)
	DRAW(12,320)
	
	DURATION(20)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,327)
	DRAW(12,320)
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,337)
	DRAW(12,320)
	
	DURATION(20)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,327)
	DRAW(12,320)
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,337)
	DRAW(12,320)
	
	DURATION(20)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,327)
	DRAW(12,320)
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,337)
	DRAW(12,320)
	
	DURATION(20)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,327)
	DRAW(12,320)
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,337)
	DRAWDROP(8,320)
	
	
	
	DURATION(20)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,327)
	DRAWDROP(12,320)
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,337)
	DRAWDROP(8,320)
	
	DURATION(20)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,327)
	DRAWDROP(8,320)
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,337)
	DRAWDROP(8,320)
	
	DURATION(20)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,327)
	DRAWDROP(8,320)
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,337)
	DRAWDROP(8,320)
	
	DURATION(20)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,327)
	DRAWDROP(8,320)
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,337)
	DRAWDROP(8,320)
	
	DURATION(20)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,327)
	DRAWDROP(9,320)
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,337)
	DRAWDROP(9,320)
	
	DURATION(20)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,327)
	DRAWDROP(9,320)
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,337)
	DRAWDROP(9,320)
	
	DURATION(20)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,327)
	DRAWDROP(9,320)
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,337)
	DRAWDROP(9,320)
	
	DURATION(20)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,327)
	DRAWDROP(9,320)
	
	DURATION(60)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,337)
	DRAWDROP(9,320)
	
	DURATION(240)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,337)
	DRAWDROP(9,320)
	
	
	DURATION(300)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,337)
	DRAWDROP(10,320)
	
	
	
	DURATION(500)
	DRAW(0,347)
	DRAW(1,377)
	DRAW(2,337)
	DRAWDROP(11,320)
	
	//!-----
	
	
	ENDANIM
	
}



int itemcount=0;


bool spacepressed;


bool quit=false;


int algdone=false;

char leveltitle[200];



int levelseed;
const int TILE_SIZE=13;
const int MARGIN=10;
const int TRIANGLE_SIZE = 50;
const int ICON_RADIUS = 10;
const int FRAMERATE=60;
const int FONT_HEIGHT=8;
int bltime;
int endmenutimer;
bool endmode;

bool gameover;
uint musictimer;

bool dragmode;
uint curnote;

uint melody_length=10;
int level_code;

struct Pos{
	int x;
	int y;
};

const Pos cubes[4] = 
{
{54,35},
{54,27},
{1,16},
{3,8}
};
bool found[4];

//0 can pass, 1 cannot fall through, 2 impassable
int map_mask[46][61];
bool deadly[46][61];

int target[2];
bool inbase[2];

Pos pos[2];
Pos base[2];

const int CIRCLECOUNT=20;

Pos circles[CIRCLECOUNT];
Pos circelvels[CIRCLECOUNT];

//used for targetting numerical enemies

#include "sound.hpp"
#include "timer.hpp"

const int ts=13;
bool leave=false;
int titletimer=0;
bool finishedtitle;

bool escpressed;
bool apressed;

bool collided;

int leveltimer;

int levelgoal;


template<int scene>
class AnimLoop
	{
	public:
		static void initialize()
		{
			badmusic();
			escpressed=false;
			bltime=0;
			finishedtitle=false;
		}
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		static void logic()
		{
			if (key[KEY_ESC]&&!escpressed)
				quit=true;
			escpressed=key[KEY_ESC];
			bltime++;
		}
		static void draw()
		{		
			clear_to_color(buffer,bgcol);
			
			CUTBARS
			
			if (anim<scene>(bltime))
				finishedtitle=true;
		}
	};



bool stoppedfather;
bool upblock;
bool trymoveto(int& x, int& y)
{
	int canmove=true;
	
	//basic bounds
	if (y<0)
	{
		y=0;
		canmove=false;
	}
	else if (y+8>SCREEN_HEIGHT)
	{
		y=SCREEN_HEIGHT-8;
		canmove=false;
	}
	if (x<0)
	{
		x=0;
		canmove=false;
	}
	else if (x+12>SCREEN_WIDTH)
	{
		x=SCREEN_WIDTH-12;
		canmove=false;
	}
	
	int oldx=x;
	bool cantmoveleft=false;
	//test left
	if (map_mask[y/TILE_SIZE][(x)/TILE_SIZE]==2||map_mask[(y+6)/TILE_SIZE][(x)/TILE_SIZE]==2)
	{
		cantmoveleft=true;
		x=(((x)/TILE_SIZE)+1)*TILE_SIZE;
		canmove=false;
	}
	
	//test right
	
	if (map_mask[y/TILE_SIZE][(x+4)/TILE_SIZE]==2||map_mask[(y+6)/TILE_SIZE][(x+4)/TILE_SIZE]==2)
	{
		if (cantmoveleft)
			x=oldx;
		else
		{
			x=((x/TILE_SIZE))*TILE_SIZE+TILE_SIZE-5;
			canmove=false;		
		}
	}
	
	
	//test up
	if (map_mask[y/TILE_SIZE][x/TILE_SIZE]==2||map_mask[y/TILE_SIZE][(x+4)/TILE_SIZE]==2)
	{
		upblock=true;
		y=((y/TILE_SIZE)+1)*TILE_SIZE;
		x=oldx;
		canmove=false;		
	}

	
	
	for (int i=0;i<4;i++)
	{
		if (!found[i])
		{
			if (x/TILE_SIZE==cubes[i].x && y/TILE_SIZE==cubes[i].y)
			{
				itemcount++;
				randmusic();
				sprintf(itemcounttext,"%d/4",itemcount);
				found[i]=true;
//				playsample(0);
			}
		}
	}

	return canmove;
}


const int T1=35;
const int T2=25;

int killtimer=0;
struct Player {
	int x;
	int y;
	int jumptimer;
	int jumpstrength;
	int frame;
	bool spacereleased;
	
	enum PState {
		S_Walking,
		S_Jumping
	} state;
	
	bool pdir;//0 right, 1 left
	
	bool on_land()
	{
		return (y>0&&((y+8)%TILE_SIZE==0)&&(y+8)<SCREEN_HEIGHT&&(map_mask[(y+8)/TILE_SIZE][(x+1)/TILE_SIZE]||map_mask[(y+8)/TILE_SIZE][(x+3)/TILE_SIZE]));
	}
	
	bool move()
	{
		if (killtimer>0)
		{
			killtimer--;
			if (killtimer==0)
				return true;
			return false;
		}
		bool moving=false;
		if (key[KEY_LEFT])
		{
			moving=true;
			pdir=1;
			x--;
		}
		else if (key[KEY_RIGHT])
		{
			moving=true;
			pdir=0;
			x++;
		}
		if ((!spacepressed)&&key[KEY_SPACE])
		{
			if (on_land())
			{
				jumptimer=T1;
				randmusic();
				spacereleased=false;
			}
		}
		
		if (upblock)
			jumptimer=0;
		upblock=false;
		
		if (jumptimer>0)
		{
			moving=false;
			jumptimer--;
			if (!spacereleased)
			{
				if (key[KEY_SPACE])
				{
					if (jumptimer<T2)
					{
						spacereleased=true;
						jumptimer+=(T1-T2);
					}
				}
				else
				{
					spacereleased=true;
					jumptimer+=(T1-jumptimer);
				}
			}
			y--;
		}
		else
		{
			if (!on_land())
			{
				moving=false;
				y++;
				if (y>0&&((y+7-10)%TILE_SIZE==0)&&(y+7-10)<SCREEN_HEIGHT&&(deadly[(y+7-10)/TILE_SIZE][(x+1)/TILE_SIZE]||deadly[(y+7-10)/TILE_SIZE][(x+3)/TILE_SIZE]))
				{
					killtimer=60;
				}
			}
		}
				
		spacepressed=key[KEY_SPACE];
		if (trymoveto(x,y))//returns true if should animate
		{
			if (moving)
			{
				static int anim=0;
				anim=(anim+1)%5;
				if (anim==0)
					frame=(frame%7)+1;
				//animation stuff
			}
		}
		else
		{
			frame=0;
		}
		
		if (jumptimer>0)
		{
			frame=4;
		}
		return false;
	}
	
	void init()
	{
		x=6*TILE_SIZE +TILE_SIZE/2 -2;
		y=44*TILE_SIZE + TILE_SIZE-8;
		spacepressed=false;
		killtimer=0;
	}
};

Player player;

class LevelLoop
	{
	public:
		static void initialize()
		{
			itemcount=0;
			escpressed=true;
			quit=false;
			finishedtitle=false;
			player.init();
			sprintf(itemcounttext,"%d/4",itemcount);
			for (int i=0;i<4;i++)
			{
			found[i]=false;
			}
		}
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		static void logic()
		{
			std::cout<<"quitting"<<quit<<endl;
			if (key[KEY_ESC])
			{
				cout<<"escpressed"<<escpressed<<endl;
				if (!escpressed)
				{
					cout<<"quitting"<<endl;
					quit=true;
				}
			}
			else escpressed=false;
			
			if (player.move())
				quit=true;
			
			if (player.x/TILE_SIZE==endx && player.y/TILE_SIZE==endy)
			{
				finishedtitle=true;
			}
		}
		static void draw()
		{
			//			clear_to_color(buffer,black);
			blit(bg, buffer, 0, 0, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
			masked_blit(playersprite, buffer, 5*player.frame, 8*player.pdir, player.x, player.y, 5, 8);
			for (int i=0;i<4;i++)
				if (!found[i])
					blit(collectable,buffer,0,0,cubes[i].x*TILE_SIZE+(TILE_SIZE/2-1),cubes[i].y*TILE_SIZE+(TILE_SIZE/2-1),3,3);
			masked_blit(fg, buffer, 0, 0, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
			textout_ex(buffer, f, itemcounttext, 5, 5, black, -1);
		}
	};

template<int i>
class BlackLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			bltime=0;
			finishedtitle=false;
		}
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		static void logic()
		{
			bltime++;
			if (bltime>i*FRAMERATE)
			{
				finishedtitle=true;
			}


			if (key[KEY_ESC]&&!escpressed)
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];

		}
		static void draw()
		{
			clear_to_color(buffer, bgcol);
		}
	};


template<class T> void loop();



int storyprogress;
bool finishedstory;
int pauseafter;



class IntroLoop
	{
	public:
		static void initialize()
		{
			spacepressed=true;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120||(mouse_b&1)||keypressed())
			{
				position_mouse(400,200);
				finishedtitle=true;
			}
		}

		static void draw()
		{
		    clear_to_color(buffer,bgcol);
			textout_centre_ex(buffer, f, "increpare presents", 160, 4*10,white, -1);

		}
	};


class IntroDialogue
	{
	public:
		static void initialize()
		{
			spacepressed=true;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
			quit=false;
		}
		
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		
		static void logic()
		{
			titletimer++;
			
			if (titletimer>120||(mouse_b&1)||keypressed())
			{
				position_mouse(400,200);
				finishedtitle=true;
			}
		}
		
		static void draw()
		{
		    clear_to_color(buffer,bgcol);
			textout_centre_ex(buffer, f, "increpare presents", 160, 4*10,white, -1);
			
		}
	};


class GameOverLoop
	{
	public:
		static void initialize()
		{

			spacepressed=true;
			quit=false;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{


			if ((key[KEY_ESC]&&!escpressed)||key[KEY_SPACE])
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];

		}

		static void draw()
		{
		    clear_to_color(buffer,bgcol);
			textout_centre_ex(buffer, f, "and you won", 160, 4*10,white, -1);
			textout_centre_ex(buffer, f, "and nothing will be the same again", 160, 5*10,white, -1);
		}
	};


class TitleLoop
	{
	public:
		static bool begin;
		static unsigned int selected;
		static bool upheld;
		static bool downheld;
		static bool spaceheld;
	public:
		static void initialize()
		{
			levelseed=1;
			spacepressed=true;
			endmode=false;
			endmenutimer=0;
			quit=false;
			begin=false;
			selected=0;
			upheld=true;
			downheld=true;
			spaceheld=true;
			escpressed=true;

		}

		static void logic()
		{

			if (endmenutimer>0)
			{
				endmenutimer--;


				return;
			}

			if (key[KEY_ESC]&&!escpressed)
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];



			if (key[KEY_UP])
			{
				if (!upheld)
				{
					randmusic();
					selected=(selected+1)%2;
					upheld=true;
				}
			}
			else
				upheld=false;

			if (key[KEY_DOWN])
			{
				if (!downheld)
				{
					randmusic();
					selected=(selected+1)%2;
					downheld=true;
				}
			}
			else
				downheld=false;

			if (key[KEY_SPACE])
			{
				if (!spaceheld)
				{
					if (selected==0)
					{
						randmusic();
						begin=true;
						endmenutimer=40;
					}
					else
					{
						randmusic();
						quit=true;
						endmenutimer=40;
					}
				}
			}
			else
				spaceheld=false;

		}

		static bool quitcondition()
		{
			return (quit||begin) && endmenutimer==0;
		}

		static void draw()
		{
            clear_to_color(buffer,bgcol);

			if ( (endmenutimer>0 && endmenutimer<10))
			{
				return;
			}

			textout_right_ex(buffer,f,"cruelty",700,2*5,makecol(255,255,255),-1);

			if (selected==0)
			{
				if (endmenutimer%2==0)
				textout_ex(buffer,f," START ",60+50,420,bgcol,makecol(255,255,255));
				textout_ex(buffer,f," Exit ",60+50,440,makecol(255,255,255),-1);
			}
			else
			{
				textout_ex(buffer,f," Start ",60+50,420,makecol(255,255,255),-1);

				if (endmenutimer%2==0)
				textout_ex(buffer,f," EXIT ",60+50,440,bgcol,makecol(255,255,255));
			}

		}

	};

bool TitleLoop::begin=false;
unsigned int TitleLoop::selected=0;
bool TitleLoop::upheld=false;
bool TitleLoop::downheld=false;
bool TitleLoop::spaceheld=true;



int endtimer=0;


template<class T>
void loop()
{

	clear_to_color(buffer, bgcol);

	T::initialize();

	while(!T::quitcondition())
	{
		al_poll_duh(dplay);

		while(speed_count>0)
		{
			poll_mouse();

			//			if (key[KEY_ESC])
			//				quit=true;

			T::logic();

			speed_count--;

		}

		T::draw();

        blit(buffer, screen, 0, 0, 0,0,SCREEN_WIDTH, SCREEN_HEIGHT);

	}
}


void blit_tile(BITMAP* bmp, int tile, int x, int y, bool mask)
{
	tile--;
	int sx=((tile%7)*TILE_SIZE);
	int sy=((tile/7)*TILE_SIZE);

	if (mask)
		masked_blit(leveltiles, bmp, sx, sy, x, y, TILE_SIZE, TILE_SIZE);
	else
		blit(leveltiles,bmp,sx,sy,x,y,TILE_SIZE,TILE_SIZE);
	
}

void init()
{

	/* initialise everything */
	allegro_init();
	init_sound();

	set_color_depth(32);

	install_keyboard();
	install_mouse();
	install_timer();


	#ifdef __APPLE__
	CGDisplayHideCursor(kCGDirectMainDisplay);
	#endif

	set_alpha_blender();

    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(FRAMERATE));

	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 800, 600, 0, 0) ;

	red=makecol(255,0,0);
	lightred=makecol(255,200,200);
	magenta=makecol(255,0,255);
	black=makecol(0,0,0);
	white=makecol(255,255,255);
	blue=makecol(0,0,255);
	bgcol=makecol(177,228,139);
	yellow=makecol(255,255,0);
	green=makecol(0,255,0);
	lightgreen=makecol(200,255,200);
	grey=makecol(100,100,100);
	lightgrey=makecol(200,200,200);
	orange=makecol(253,183,58);
	purp0=makecol(107,30,98);
	purp1=makecol(199,40,162);
	purp2=makecol(255,220,255);

	//load save data


	//init the buffer
	buffer=create_bitmap(SCREEN_WIDTH, SCREEN_HEIGHT);
	leveltiles=load_bitmap("bmp/leveltiles.bmp", NULL);
	playersprite=load_bitmap("bmp/playersprite.bmp", NULL);
	vignette=load_bitmap("bmp/vignettes.bmp",NULL);
	collectable=load_bitmap("bmp/box.bmp",NULL);
	f=load_bitmap_font("bmp/font.pcx",NULL,NULL);
	if (f==0)
	{
		exit(0);
	}
	bg=create_bitmap(SCREEN_WIDTH,SCREEN_HEIGHT);
	fg=create_bitmap(SCREEN_WIDTH,SCREEN_HEIGHT);
	clear_to_color(fg, magenta);
	
	for (int i=0;i<61;i++)
		for (int j=0;j<46;j++)
		{
			switch (map_map[j][i])
			{
				case 8:
				case 9:
				case 10:
					blit_tile(fg,map_map[j][i],i*TILE_SIZE,j*TILE_SIZE,true);
					blit_tile(bg,1,i*TILE_SIZE,j*TILE_SIZE,false);
					break;
				case 15:
				case 16:
					blit_tile(fg,map_map[j][i],i*TILE_SIZE,j*TILE_SIZE,true);
					blit_tile(bg,map_map[j-1][i],i*TILE_SIZE,j*TILE_SIZE,false);
					break;
				case 19:
				case 26:
				case 27:
					blit_tile(bg, map_map[j][i], i*TILE_SIZE, j*TILE_SIZE, false);
					blit_tile(fg, map_map[j][i], i*TILE_SIZE, j*TILE_SIZE, false);					
					break;
				default:
					blit_tile(bg, map_map[j][i], i*TILE_SIZE, j*TILE_SIZE, false);
					break;
			}
			
			switch(map_map[j][i])
			{
				//impassible
				case 29:
				case 30:
				case 36:
				case 37:
				case 31:
				case 20:
					map_mask[j][i]=2;
					break;
				//can jump through
				case 22:
				case 23:
				case 24:
				case 17:
					map_mask[j][i]=1;
					break;
				default:
					//can pass
					map_mask[j][i]=0;
					break;
			}
			
			switch(map_map[j][i])
			{
				case 15:
				case 16:
					deadly[j][i]=true;
					break;
				default:
					deadly[j][i]=false;
					break;
			}
		}
}

int dir;
int px;
int py;

bool gototitle=false;

int main(int argc, char *argv[])
{

	init();


	loop<IntroLoop>();

titletag:
	gototitle=false;

	randmusic();
	loop<TitleLoop>();

	if (quit)
		goto end;

	if (quit)
	{
		gototitle=true;
		goto menuskip;
	}

	randmusic();
	loop<LevelLoop >();

	if (finishedtitle)
	{
		switch (itemcount)
		{
			case 0:
				loop<AnimLoop<0> > ();
				break;
			case 1:
				loop<AnimLoop<1> > ();
				break;
			case 2:
				loop<AnimLoop<2> > ();
				break;
			case 3:
				loop<AnimLoop<3> > ();
				break;
			case 4:
				loop<AnimLoop<4> > ();
				break;
		}
	}



menuskip:
	quit=false;
	finishedtitle=false;
	TitleLoop::begin=false;
	goto titletag;

end:
	quit=false;
	return 0;

}
END_OF_MAIN()
